# exported should

# exported co

# jshint expr: true
"use strict"


require("coffee-script");

config = require("/data/config.json");
aggConfig = config.agg;
zmq = require('zmq');
host = aggConfig.protocol + "://" + aggConfig.address + ":";
pullSocket = zmq.socket("pull");
pullSocket.bindSync("" + host + aggConfig.subscriberPoolPort);

omg_gatelogs = require("../lib/omg-gatelogs")

exec = require("child_process").exec
_ = require("lodash")
describe "omg_gatelogs", ->

    it 'should listen for 0.1 minute when handed 0.1 as a string as an argument', (done) ->
        runTime = 0.1
        @timeout 1000 * 60 * runTime + 1000
        omg_gatelogs.start runTime
        onMessage = (data) ->
            data = JSON.parse(data)
            data.producer.should.be.exactly "gatelogs"
            console.log data
            console.log "started successfuly"   if data.status is "started"
            console.log data.data   if data.data
            if data.status is "stopped"
                done()
                pullSocket.removeListener "message", onMessage
            return

        pullSocket.on "message", onMessage

    ### jshint ignore:start###
    return
    describe "omg_gatelogs emit", ->
        # @timeout 10000
        it "should emit started", (done) ->
            startCallback = (err, data) ->
                console.log data if data
                throw err   if err
                return

            outputCallback = (err) ->
                throw err   if err
                return

            stoppedAlready = false
            onStatus = (message) ->
                console.log "gatelogs emitted: #{message}"
                if not stoppedAlready
                    stoppedAlready = true if message is "stopped"
                    stop = ->
                        omg_gatelogs.stop()
                    stop() if message is "running"
                    if message is "stopped"
                        omg_gatelogs.removeListener "status", onStatus
                        done()

            omg_gatelogs.on "status", onStatus

            omg_gatelogs.start 3, startCallback, outputCallback


    describe "omg_gatelogs.start", ->
        @timeout 10000
        it "should start logger and receive data through a callback or through an emitter", (done) ->
            dataThroughCallback = false
            dataThroughemitter = false

            stcb = ->
                 # log something specific
                logIt = () ->
                    exec("logger testcode1234567")
                setTimeout logIt, 1500

            outcb = (err, data) ->
                throw err   if err
                data.should.not.be.empty
                if data
                    _.each data, (line) ->
                        dataThroughCallback = true if line.indexOf("testcode1234567") > -1

            onData = (data) ->
                data.should.not.be.empty
                if data
                    _.each data, (line) ->
                        dataThroughemitter = true if line.indexOf("testcode1234567") > -1

                    if dataThroughCallback and dataThroughemitter
                        done()
                        omg_gatelogs.removeListener "data", onData

            omg_gatelogs.on "data", onData
            omg_gatelogs.start 2, stcb, outcb

    describe "omg_gatelogs.getAllLogs", ->
        it "should get all loglines", (done) ->
            omg_gatelogs.getAllLogs (->
                console.log "successfully started tail"
                return
            ), (err, data) ->
                throw err   if err
                data.should.not.be.empty
                data.should.be.array
                done()

    describe "omg_gatelogs.getStatus", ->
        it "should not return an error", (done) ->
            omg_gatelogs.getStatus (err, success) ->
                throw err   if err
                success.should.be.equal "running"
                done()

    describe "omg_gatelogs.stop", ->
        it "should not return an error", (done) ->
            omg_gatelogs.stop (err) ->
                err.should.be.equal "regular stop"
                done()


    describe "omg_gatelogs.getStatus", ->
        it "should not return an error", (done) ->
            omg_gatelogs.getStatus (err, success) ->
                throw err   if err
                success.should.be.equal "stopped"
                done()

    describe "omg_gatelogs.start", ->
        @timeout(5000)
        it "should not crash if no callbacks were passed", (done) ->
            onData = (data) ->
                omg_gatelogs.removeListener "data", onData
                done()

            omg_gatelogs.on("status", onData)
            exec "logger hu"
            omg_gatelogs.start()

