// Generated by CoffeeScript 1.9.0
'use strict';
var Hostinspection, Producer, appConfig, debug, runAsRoot, spawn,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

spawn = require("child_process").spawn;

appConfig = global.appConfig;

if (appConfig) {
  runAsRoot = appConfig.sudo || false;
}

debug = require("debug")("omg-hostinspection");

Producer = require("class_node_producer");

Hostinspection = (function(_super) {
  var isRunning;

  __extends(Hostinspection, _super);

  isRunning = false;

  function Hostinspection() {
    var run;
    Hostinspection.__super__.constructor.call(this, "hostinspection");
    run = (function(_this) {
      return function(command, args) {
        var runningCommand;
        _this.sendStatus("running");
        runningCommand = spawn(command, args);
        runningCommand.stdout.on("data", function(data) {
          var lines;
          lines = data.toString('utf-8');
          lines = lines.split('\n');
          lines.pop();
          return _this.sendData(lines, true);
        });
        runningCommand.stderr.on("data", function(data) {
          return debug("data " + data);
        });
        runningCommand.on("error", function(e) {
          return debug(e);
        });
        return runningCommand.on("close", function(returnCode) {
          return _this.sendStatus("stopped");
        });
      };
    })(this);
    this.ping = (function(_this) {
      return function(host) {
        var args, command;
        command = "ping";
        host = host || "127.0.0.1";
        args = ["-c", "4", host];
        return run(command, args);
      };
    })(this);
    this.tracepath = (function(_this) {
      return function(host) {
        var args, command;
        command = "tracepath";
        host = host || "127.0.0.1";
        args = [host];
        return run(command, args);
      };
    })(this);
    this.dnslookup = (function(_this) {
      return function(host) {
        var args, command;
        command = "dig";
        host = host || "127.0.0.1";
        args = [host];
        return run(command, args);
      };
    })(this);
    this.portscan = (function(_this) {
      return function(host) {
        var args, command;
        host = host || "127.0.0.1";
        command = "";
        if (runAsRoot) {
          command = "sudo";
          args = ["nmap", "-PO", "-vv"];
        }
        if (!runAsRoot) {
          command = "nmap";
          args = ["-PO", "-vv"];
        }
        args.push("tcp");
        args.push(host);
        return run(command, args);
      };
    })(this);
    this.portprobe = (function(_this) {
      return function(host, proto, port) {
        var args, command;
        if (!(host && proto && port)) {
          debug("host, protocol and port have to be specified");
          return;
        }
        command = "";
        if (runAsRoot) {
          command = "sudo";
          args = ["nmap", "-PO", "-vv"];
        }
        if (!runAsRoot) {
          command = "nmap";
          args = ["-PO", "-vv"];
        }
        if (proto === "tcp") {
          args.push("-sT");
        }
        if (proto === "udp") {
          args.push("-sU");
        }
        args.push(host);
        args.push("-p");
        args.push(port);
        return run(command, args);
      };
    })(this);
  }

  return Hostinspection;

})(Producer);

module.exports = new Hostinspection();
