ko = require 'knockout'

Producer = require 'class_node_producer'
parseLogLines = require './logLineParser'

debug = require("debug")("omg-testcall:logs")

testcallFolder = "/tmp/testcall"

class Gatelogs extends Producer
  constructor: ->
    super "gatelogsfromTestcall"
    @running = ko.observable(false)

    onMessage = (err, status, message) =>
      @running((if status is "running" then true else false))

      if message
        #convert loglines to Layer 3 Messages L3D and send important lines
        outArray = parseLogLines message
        @emit "data", outArray if outArray.length

    @subscribeTo "gatelogs", onMessage

  start: ->
    debug "Testcall is requesting gatelogs to start"
    requestObject =
      producer: "gatelogs"
      action: "start"
      args: [2]
    @sendCommand requestObject


  stop: ->
    debug "Testcall is requesting gatelogs to start"
    requestObject =
      producer: "gatelogs"
      action: "stop"
    @sendCommand requestObject

module.exports = new Gatelogs()
