
"use strict"
exec = require("child_process").exec
_ = require "lodash"
shell = require("shelljs")
ko = require "knockout"
debug = require("debug")("omg-testcall")
Producer = require "class_node_producer"
call = require './call'
logs = require './logs'

testcallFolder = "/tmp/testcall"

#create testcall folder where options and logs will be stored
shell.mkdir testcallFolder if not shell.test "-e", testcallFolder
#copy all files that need write access to new testcall folder
shell.cp "-f", __dirname + "/files/*", "#{testcallFolder}/"


removeOldCallLogs = (asyncCallback) ->
  exec "rm -f #{testcallFolder}/*.log", (e, out) -> #error , stdout , stderr
    asyncCallback e, out

checkFreePort = (asyncCallback) ->
  freeport (error, aFreePort) ->
    asyncCallback error, aFreePort

class Testcall extends Producer
  constructor: ->
    super "testcall"
    @status = "stopped"
    @gatelogsRunning = logs.running
    callRunning = call.running
    @callIsWaiting = false

    callRunning.subscribe (val) ->
      unless val
        logs.stop()

    @gatelogsOrCallRunning = ko.computed
      read: =>
        if @gatelogsRunning() or callRunning()
          return true
        else
          return false
      deferEvaluation: true

    statusSender = ko.computed =>
      if callRunning()
        @sendStatus "running"
        @status = "running"
        debug "Call is running"
      else
        @sendStatus "stopped"
        @status = "stopped"

      unless @gatelogsOrCallRunning()
        @sendStatus "stopped"
        @status = "stopped"
        debug "Log and call not running"

    logs.on "data", (data) =>
      @sendData data

    call.on "finished", ->
      debug "call finished, stopping logs"
      logs.stop()


  start: (callObject) =>
    debug "starting call"
    if @gatelogsOrCallRunning()

      #set dirty flag so not more than one calls can be waiting
      #if there is already another call waiting, don't proceed
      if @callIsWaiting
        return
      else
        @callIsWaiting = true

      # wait for gatelogs and call to stop, then try again
      retryWhenAllStopped = @gatelogsOrCallRunning.subscribe (stillRunning) =>
        unless stillRunning
          debug "Previous call and gatelogs stopped. Running new call"
          retryWhenAllStopped.dispose()
          @start callObject
          @callIsWaiting = false

      @sendData ["Waiting for previous call to finish."]
      debug "Waiting for previous call to finish."
      logs.stop()

      # don't proceed with new call
      return


    @sendStatus "started"
    debug "starting logs and call"

    if @gatelogsRunning()
      call.start(callObject)
    else
      startWhenLogsAreRunning = @gatelogsRunning.subscribe (val) ->
        if val
          startWhenLogsAreRunning.dispose()
          call.start(callObject)
    logs.start()

  stop: (callback) ->
    logs.stop()
    call.stop()

module.exports = new Testcall()